% Function DRMO_comparison calculates PID controller parameters based on
% Magnitude optimum for disturbance-rejection performance optimisation and
% some other methods (RZN, ZN, CHR)

Param1=[];

% ------------------------------------------------------------------------
% Process Gp1
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=1;den=[1 1];den=conv(den,[9 1]);den1=conv(den,[Tf 1]);Tdelay=0; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

a1f = a1/a0;
a2f = a2/a0;
b1f = b1/b0;
b2f = b2/b0;
Param1=[Param1;Ki1,K1,Kd1,Ki2,K2,Kd2];

Kpr = num(max(size(num)))/den(max(size(den)));		% Process steady-state gain

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd1 = y;
yd12 = y2;
yd14 = y4;
yf1 = yf;
yb1 = yb;
ydd1 = yd;

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd1d = y;
yd12d = y2;
yd14d = y4;
yf1d = yf;
yb1d = yb;
ydd1d = yd;


% ------------------------------------------------------------------------
% Process Gp2
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=[1 1];den=[8 1];den=conv(den,[1.5 1]);den=conv(den,[1.5 1]);den1=conv(den,[Tf 1]);Tdelay=0; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

a1f = a1/a0;
a2f = a2/a0;
b1f = b1/b0;
b2f = b2/b0;
Param1=[Param1;Ki1,K1,Kd1,Ki2,K2,Kd2];

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = Tstop/2;	% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd2 = y;
yd22 = y2;
yd24 = y4;
yf2 = yf;
yb2 = yb;
ydd2 = yd;

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd2d = y;
yd22d = y2;
yd24d = y4;
yf2d = yf;
yb2d = yb;
ydd2d = yd;



% ------------------------------------------------------------------------
% Process Gp3
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=[-2 1];den=[4 1];den=conv(den,[4 1]);den1=conv(den,[Tf 1]);Tdelay=0; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

a1f = a1/a0;
a2f = a2/a0;
b1f = b1/b0;
b2f = b2/b0;
Param1=[Param1;Ki1,K1,Kd1,Ki2,K2,Kd2];


% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = Tstop/2;	% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd3 = y;
yd32 = y2;
yd34 = y4;
yf3 = yf;
yb3 = yb;
ydd3 = yd;

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd3d = y;
yd32d = y2;
yd34d = y4;
yf3d = yf;
yb3d = yb;
ydd3d = yd;


% ------------------------------------------------------------------------
% Process Gp4
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=[1];den=[1 1];den=conv(den,den);den=conv(den,den);den=conv(den,den);den1=conv(den,[Tf 1]);Tdelay=2; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

a1f = a1/a0;
a2f = a2/a0;
b1f = b1/b0;
b2f = b2/b0;
Param1=[Param1;Ki1,K1,Kd1,Ki2,K2,Kd2];


% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = Tstop/2;	% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd4 = y;
yd42 = y2;
yd44 = y4;
yf4 = yf;
yb4 = yb;
ydd4 = yd;

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt24');

yd4d = y;
yd42d = y2;
yd44d = y4;
yf4d = yf;
yb4d = yb;
ydd4d = yd;


figure(1);
plot_more ([yd1(:,1),yd1(:,4),yd2(:,4),yd3(:,4),yd4(:,4)],'Process closed-loop responses','t [s]',{'G_P_1','G_P_2','G_P_3','G_P_4'},500,20);

print -depsc drmo_qcomp1.eps
print -deps drmo_qcomp1bw.eps
print -dmfile drmo_qcomp1


figure(2);
plot_more ([yd1d(:,1),yd1d(:,4),yd2d(:,4),yd3d(:,4),yd4d(:,4)],'Process closed-loop responses','t [s]',{'G_P_1','G_P_2','G_P_3','G_P_4'},500,20);

print -depsc drmo_qcomp2.eps
print -deps drmo_qcomp2bw.eps
print -dmfile drmo_qcomp2


figure(3);
plot_more ([yd1d(:,1),yd1d(:,5),yd2d(:,5),yd3d(:,5),yd4d(:,5)],'Process closed-loop responses','t [s]',{'G_P_1','G_P_2','G_P_3','G_P_4'},500,20);

print -depsc drmo_qcomp3.eps
print -deps drmo_qcomp3bw.eps
print -dmfile drmo_qcomp3



figure(4);
subplot(221);
plot_more ([yd1(:,1),yd1(:,4),yf1(:,4)],'Process G_P_1 closed-loop response','t [s]',{'MO','DRMO & FPID'},500,20,[0 15 0 1.2]);

subplot(222);
plot_more ([yd2(:,1),yd2(:,4),yf2(:,4)],'Process G_P_2 closed-loop response','t [s]',{'MO','DRMO & FPID'},500,20,[0 30 0 1.2]);

subplot(223);
plot_more ([yd3(:,1),yd3(:,4),yf3(:,4)],'Process G_P_3 closed-loop response','t [s]',{'MO','DRMO & FPID'},500,20,[0 40 -0.4 1.2]);

subplot(224);
plot_more ([yd4(:,1),yd4(:,4),yf4(:,4)],'Process G_P_4 closed-loop response','t [s]',{'MO','DRMO & FPID'},500,20,[0 60 0 1.2]);

print -depsc drmo_qcomp4.eps
print -deps drmo_qcomp4bw.eps
print -dmfile drmo_qcomp4



figure(5);
subplot(221);
plot_more ([yf1d(:,1),yf1d(:,4),yd1d(:,4)],'Process G_P_1 disturbance rejection','t [s]',{'DRMO','MO'},500,20,[0 15 -0.02 0.08]);

subplot(222);
plot_more ([yf2d(:,1),yf2d(:,4),yd2d(:,4)],'Process G_P_2 disturbance rejection','t [s]',{'DRMO','MO'},500,20,[0 30 -0.05 0.12]);

subplot(223);
plot_more ([yf3d(:,1),yf3d(:,4),yd3d(:,4)],'Process G_P_3 disturbance rejection','t [s]',{'DRMO','MO'},500,20,[0 40 -0.2 0.5]);

subplot(224);
plot_more ([yf4d(:,1),yf4d(:,4),yd4d(:,4)],'Process G_P_4 disturbance rejection','t [s]',{'DRMO','MO'},500,20,[0 60 -0.2 1]);

print -depsc drmo_qcomp5.eps
print -deps drmo_qcomp5bw.eps
print -dmfile drmo_qcomp5



figure(6);
subplot(221);
plot_more ([ydd1(:,1),ydd1(:,4),yd1(:,4)],'Process G_P_1 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 15 0 1.6]);

subplot(222);
plot_more ([ydd2(:,1),ydd2(:,4),yd2(:,4)],'Process G_P_2 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 30 0 1.5]);

subplot(223);
plot_more ([ydd3(:,1),ydd3(:,4),yd3(:,4)],'Process G_P_3 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 40 -0.7 1.7]);

subplot(224);
plot_more ([ydd4(:,1),ydd4(:,4),yd4(:,4)],'Process G_P_4 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 60 0 1.3]);

print -depsc drmo_qcomp6.eps
print -deps drmo_qcomp6bw.eps
print -dmfile drmo_qcomp6



figure(7);
subplot(221);
plot_more ([yb1(:,1),yb1(:,4),yd1(:,4)],'Process G_P_1 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 15 0 1.2]);

subplot(222);
plot_more ([yb2(:,1),yb2(:,4),yd2(:,4)],'Process G_P_2 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 30 0 1.2]);

subplot(223);
plot_more ([yb3(:,1),yb3(:,4),yd3(:,4)],'Process G_P_3 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 40 -0.4 1.2]);

subplot(224);
plot_more ([yb4(:,1),yb4(:,4),yd4(:,4)],'Process G_P_4 closed-loop response','t [s]',{'DRMO','MO'},500,20,[0 60 0 1.2]);

print -depsc drmo_qcomp7.eps
print -deps drmo_qcomp7bw.eps
print -dmfile drmo_qcomp7


figure(8);
subplot(221);
plot_more ([yd1(:,1),yd1(:,4),yd12(:,4),yd14(:,4)],'Process G_P_1 closed-loop response','t [s]',{'MO','FPID 4^t^h order','FPID 2^n^d order'},500,20,[0 15 0 1.2]);

subplot(222);
plot_more ([yd2(:,1),yd2(:,4),yd22(:,4),yd24(:,4)],'Process G_P_2 closed-loop response','t [s]',{'MO','FPID 4^t^h order','FPID 2^n^d order'},500,20,[0 30 0 1.2]);

subplot(223);
plot_more ([yd3(:,1),yd3(:,4),yd32(:,4),yd34(:,4)],'Process G_P_3 closed-loop response','t [s]',{'MO','FPID 4^t^h order','FPID 2^n^d order'},500,20,[0 40 -0.4 1.2]);

subplot(224);
plot_more ([yd4(:,1),yd4(:,4),yd42(:,4),yd44(:,4)],'Process G_P_4 closed-loop response','t [s]',{'MO','FPID 4^t^h order','FPID 2^n^d order'},500,20,[0 60 0 1.2]);

print -depsc drmo_qcomp8.eps
print -deps drmo_qcomp8bw.eps
print -dmfile drmo_qcomp8

