% Function DRMO_comparison calculates PID controller parameters based on
% Magnitude optimum for disturbance-rejection performance optimisation and
% some other methods (RZN, ZN, CHR)

Param1=[];
Filtv=[];
tv = [0:0.001:100]';

% ------------------------------------------------------------------------
% Process Gp1
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=1;den=[1 1];den=conv(den,[9 1]);den1=conv(den,[Tf 1]);Tdelay=0; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

Kpr = num(max(size(num)))/den(max(size(den)));		% Process steady-state gain
[tl,tr,trah] = find_tltr_compah (num,den1,Tdelay,tv);

[Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20] = refzn_pid20 (trah,tl,Kpr);
[Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14] = refzn_pid14 (trah,tl,Kpr);
[Kp_chr,Ki_chr,Kd_chr,b_chr] = chrpid20dist (tr,tl,Kpr);
[Kp_am,Ki_am,Kd_am,b_am] = amigopid (trah,tl,Kpr);
[Kp_IAE,Ki_IAE,Kd_IAE,b_IAE] = IAEPID_load (tr,tl,Kpr);

Param = [K2,Ki2,Kd2,0,Kp_chr,Ki_chr,Kd_chr,b_chr,Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14,Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20,Kp_IAE,Ki_IAE,Kd_IAE,b_IAE,Kp_am,Ki_am,Kd_am,b_am];
Param1 = [Param1;Param];
Filtv=[Filtv;a0 a1 a2 a3 a4 b0 b1 b2 b3 b4];

% Setting experiment parameters
Tstop = 15;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop1 = Tstop;
yd1 = y_drmo;
yd1_20 = y_rzn20;
yd1_14 = y_rzn14;
yd1_iae = y_IAE;
yd1_am = y_am;
yd1_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 100;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vd1_drmo] = calc_crit0 (y_drmo);
[crit_vd1_rzn20] = calc_crit0 (y_rzn20);
[crit_vd1_rzn14] = calc_crit0 (y_rzn14);
[crit_vd1_IAE] = calc_crit0 (y_IAE);
[crit_vd1_am] = calc_crit0 (y_am);
[crit_vd1_chr] = calc_crit0 (y_chr);

% Setting experiment parameters
Tstop = 15;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop1 = Tstop;
yr1 = y_drmo;
yr1_20 = y_rzn20;
yr1_14 = y_rzn14;
yr1_iae = y_IAE;
yr1_am = y_am;
yr1_chr = y_chr;


% Setting experiment parameters for criteria
Tstop = 100;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vr1_drmo] = calc_crit0 (y_drmo);
[crit_vr1_rzn20] = calc_crit0 (y_rzn20);
[crit_vr1_rzn14] = calc_crit0 (y_rzn14);
[crit_vr1_IAE] = calc_crit0 (y_IAE);
[crit_vr1_am] = calc_crit0 (y_am);
[crit_vr1_chr] = calc_crit0 (y_chr);

% ------------------------------------------------------------------------
% Process Gp2
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=[1 1];den=[8 1];den=conv(den,[1.5 1]);den=conv(den,[1.5 1]);den1=conv(den,[Tf 1]);Tdelay=0; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

Kpr = num(max(size(num)))/den(max(size(den)));		% Process steady-state gain
[tl,tr,trah] = find_tltr_compah (num,den1,Tdelay,tv);

[Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20] = refzn_pid20 (trah,tl,Kpr);
[Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14] = refzn_pid14 (trah,tl,Kpr);
[Kp_chr,Ki_chr,Kd_chr,b_chr] = chrpid20dist (tr,tl,Kpr);
[Kp_am,Ki_am,Kd_am,b_am] = amigopid (trah,tl,Kpr);
[Kp_IAE,Ki_IAE,Kd_IAE,b_IAE] = IAEPID_load (tr,tl,Kpr);

Param = [K2,Ki2,Kd2,0,Kp_chr,Ki_chr,Kd_chr,b_chr,Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14,Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20,Kp_IAE,Ki_IAE,Kd_IAE,b_IAE,Kp_am,Ki_am,Kd_am,b_am];
Param1 = [Param1;Param];
Filtv=[Filtv;a0 a1 a2 a3 a4 b0 b1 b2 b3 b4];

% Setting experiment parameters
Tstop = 30;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop2 = Tstop;
yd2 = y_drmo;
yd2_20 = y_rzn20;
yd2_14 = y_rzn14;
yd2_iae = y_IAE;
yd2_am = y_am;
yd2_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 100;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vd2_drmo] = calc_crit0 (y_drmo);
[crit_vd2_rzn20] = calc_crit0 (y_rzn20);
[crit_vd2_rzn14] = calc_crit0 (y_rzn14);
[crit_vd2_IAE] = calc_crit0 (y_IAE);
[crit_vd2_am] = calc_crit0 (y_am);
[crit_vd2_chr] = calc_crit0 (y_chr);


% Setting experiment parameters
Tstop = 30;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop2 = Tstop;
yr2 = y_drmo;
yr2_20 = y_rzn20;
yr2_14 = y_rzn14;
yr2_iae = y_IAE;
yr2_am = y_am;
yr2_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 100;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vr2_drmo] = calc_crit0 (y_drmo);
[crit_vr2_rzn20] = calc_crit0 (y_rzn20);
[crit_vr2_rzn14] = calc_crit0 (y_rzn14);
[crit_vr2_IAE] = calc_crit0 (y_IAE);
[crit_vr2_am] = calc_crit0 (y_am);
[crit_vr2_chr] = calc_crit0 (y_chr);


% ------------------------------------------------------------------------
% Process Gp3
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=[-2 1];den=[4 1];den=conv(den,[4 1]);den1=conv(den,[Tf 1]);Tdelay=0; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

Kpr = num(max(size(num)))/den(max(size(den)));		% Process steady-state gain
[tl,tr,trah] = find_tltr_compah (num,den1,Tdelay,tv);

[Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20] = refzn_pid20 (trah,tl,Kpr);
[Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14] = refzn_pid14 (trah,tl,Kpr);
[Kp_chr,Ki_chr,Kd_chr,b_chr] = chrpid20dist (tr,tl,Kpr);
[Kp_am,Ki_am,Kd_am,b_am] = amigopid (trah,tl,Kpr);
[Kp_IAE,Ki_IAE,Kd_IAE,b_IAE] = IAEPID_load (tr,tl,Kpr);

Param = [K2,Ki2,Kd2,0,Kp_chr,Ki_chr,Kd_chr,b_chr,Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14,Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20,Kp_IAE,Ki_IAE,Kd_IAE,b_IAE,Kp_am,Ki_am,Kd_am,b_am];
Param1 = [Param1;Param];
Filtv=[Filtv;a0 a1 a2 a3 a4 b0 b1 b2 b3 b4];

% Setting experiment parameters
Tstop = 40;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop3 = Tstop;
yd3 = y_drmo;
yd3_20 = y_rzn20;
yd3_14 = y_rzn14;
yd3_iae = y_IAE;
yd3_am = y_am;
yd3_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 200;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vd3_drmo] = calc_crit0 (y_drmo);
[crit_vd3_rzn20] = calc_crit0 (y_rzn20);
[crit_vd3_rzn14] = calc_crit0 (y_rzn14);
[crit_vd3_IAE] = calc_crit0 (y_IAE);
[crit_vd3_am] = calc_crit0 (y_am);
[crit_vd3_chr] = calc_crit0 (y_chr);


% Setting experiment parameters
Tstop = 40;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop3 = Tstop;
yr3 = y_drmo;
yr3_20 = y_rzn20;
yr3_14 = y_rzn14;
yr3_iae = y_IAE;
yr3_am = y_am;
yr3_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 200;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vr3_drmo] = calc_crit0 (y_drmo);
[crit_vr3_rzn20] = calc_crit0 (y_rzn20);
[crit_vr3_rzn14] = calc_crit0 (y_rzn14);
[crit_vr3_IAE] = calc_crit0 (y_IAE);
[crit_vr3_am] = calc_crit0 (y_am);
[crit_vr3_chr] = calc_crit0 (y_chr);



% ------------------------------------------------------------------------
% Process Gp4
% ------------------------------------------------------------------------

Tf=0.5;		% PID filter time constant
% process parameters
num=[1];den=[1 1];den=conv(den,den);den=conv(den,den);den=conv(den,den);den1=conv(den,[Tf 1]);Tdelay=2; 

[Ki1,K1,Kd1,Ki2,K2,Kd2,b0,b1,b2,b3,b4,a0,a1,a2,a3,a4] = area2PID_filter_r (num,den,Tdelay,Tf);

Kpr = num(max(size(num)))/den(max(size(den)));		% Process steady-state gain
[tl,tr,trah] = find_tltr_compah (num,den1,Tdelay,tv);

[Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20] = refzn_pid20 (trah,tl,Kpr);
[Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14] = refzn_pid14 (trah,tl,Kpr);
[Kp_chr,Ki_chr,Kd_chr,b_chr] = chrpid20dist (tr,tl,Kpr);
[Kp_am,Ki_am,Kd_am,b_am] = amigopid (trah,tl,Kpr);
[Kp_IAE,Ki_IAE,Kd_IAE,b_IAE] = IAEPID_load (tr,tl,Kpr);

Param = [K2,Ki2,Kd2,0,Kp_chr,Ki_chr,Kd_chr,b_chr,Kp_rzn14,Ki_rzn14,Kd_rzn14,b_rzn14,Kp_rzn20,Ki_rzn20,Kd_rzn20,b_rzn20,Kp_IAE,Ki_IAE,Kd_IAE,b_IAE,Kp_am,Ki_am,Kd_am,b_am];
Param1 = [Param1;Param];
Filtv=[Filtv;a0 a1 a2 a3 a4 b0 b1 b2 b3 b4];

% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop4 = Tstop;
yd4 = y_drmo;
yd4_20 = y_rzn20;
yd4_14 = y_rzn14;
yd4_iae = y_IAE;
yd4_am = y_am;
yd4_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 200;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 1;			% Amplitude of disturbance
r = 0;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vd4_drmo] = calc_crit0 (y_drmo);
[crit_vd4_rzn20] = calc_crit0 (y_rzn20);
[crit_vd4_rzn14] = calc_crit0 (y_rzn14);
[crit_vd4_IAE] = calc_crit0 (y_IAE);
[crit_vd4_am] = calc_crit0 (y_am);
[crit_vd4_chr] = calc_crit0 (y_chr);



% Setting experiment parameters
Tstop = 60;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

Tstop4 = Tstop;
yr4 = y_drmo;
yr4_20 = y_rzn20;
yr4_14 = y_rzn14;
yr4_iae = y_IAE;
yr4_am = y_am;
yr4_chr = y_chr;

% Setting experiment parameters for criteria
Tstop = 200;			% Time of experiment
Tstep1 = 0;			% Time of reference change
Tdist = 0;			% Time of disturbance
Dist = 0;			% Amplitude of disturbance
r = 1;				% Amplitude of the reference

% Simulation
sim ('pid_filt_test');

[crit_vr4_drmo] = calc_crit0 (y_drmo);
[crit_vr4_rzn20] = calc_crit0 (y_rzn20);
[crit_vr4_rzn14] = calc_crit0 (y_rzn14);
[crit_vr4_IAE] = calc_crit0 (y_IAE);
[crit_vr4_am] = calc_crit0 (y_am);
[crit_vr4_chr] = calc_crit0 (y_chr);



figure(1);
subplot(221);
plot_more ([yd1(:,1),yd1(:,4),yd1_14(:,4),yd1_20(:,4),yd1_iae(:,4)],'Process G_P_1 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(222);
plot_more ([yd1(:,1),yd1(:,4),yd1_am(:,4),yd1_chr(:,4)],'Process G_P_1 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,40);

subplot(223);
plot_more ([yd2(:,1),yd2(:,4),yd2_14(:,4),yd2_20(:,4),yd2_iae(:,4)],'Process G_P_2 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(224);
plot_more ([yd2(:,1),yd2(:,4),yd2_am(:,4),yd2_chr(:,4)],'Process G_P_2 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,40);

print -depsc drmo_comp1.eps
print -deps drmo_compbw1.eps
print -dmfile drmo_comp1


figure(2);
subplot(221);
plot_more ([yd3(:,1),yd3(:,4),yd3_14(:,4),yd3_20(:,4),yd3_iae(:,4)],'Process G_P_3 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(222);
plot_more ([yd3(:,1),yd3(:,4),yd3_am(:,4),yd3_chr(:,4)],'Process G_P_3 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,20);

subplot(223);
plot_more ([yd4(:,1),yd4(:,4),yd4_14(:,4),yd4_20(:,4),yd4_iae(:,4)],'Process G_P_4 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(224);
plot_more ([yd4(:,1),yd4(:,4),yd4_am(:,4),yd4_chr(:,4)],'Process G_P_4 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,20);

print -depsc drmo_comp2.eps
print -deps drmo_compbw2.eps
print -dmfile drmo_comp2



figure(3);
subplot(221);
plot_more ([yr1(:,1),yr1(:,4),yr1_14(:,4),yr1_20(:,4),yr1_iae(:,4)],'Process G_P_1 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(222);
plot_more ([yr1(:,1),yr1(:,4),yr1_am(:,4),yr1_chr(:,4)],'Process G_P_1 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,40);

subplot(223);
plot_more ([yr2(:,1),yr2(:,4),yr2_14(:,4),yr2_20(:,4),yr2_iae(:,4)],'Process G_P_2 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(224);
plot_more ([yr2(:,1),yr2(:,4),yr2_am(:,4),yr2_chr(:,4)],'Process G_P_2 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,40);

print -depsc drmo_comp3.eps
print -deps drmo_compbw3.eps
print -dmfile drmo_comp3


figure(4);
subplot(221);
plot_more ([yr3(:,1),yr3(:,4),yr3_14(:,4),yr3_20(:,4),yr3_iae(:,4)],'Process G_P_3 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(222);
plot_more ([yr3(:,1),yr3(:,4),yr3_am(:,4),yr3_chr(:,4)],'Process G_P_3 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,20);

subplot(223);
plot_more ([yr4(:,1),yr4(:,4),yr4_14(:,4),yr4_20(:,4),yr4_iae(:,4)],'Process G_P_4 closed-loop responses','time [s]',{'DRMO','RZN14','RZN20','IAE'},500,20);

subplot(224);
plot_more ([yr4(:,1),yr4(:,4),yr4_am(:,4),yr4_chr(:,4)],'Process G_P_4 closed-loop responses','time [s]',{'DRMO','AMIGO','CHR'},500,20);

print -depsc drmo_comp4.eps
print -deps drmo_compbw4.eps
print -dmfile drmo_comp4

disp(' ');
disp('Crit GP1 D');
[crit_vd1_drmo crit_vd1_rzn20 crit_vd1_rzn14 crit_vd1_IAE crit_vd1_am crit_vd1_chr]
disp(' ');
disp('Crit GP1 R');
[crit_vr1_drmo crit_vr1_rzn20 crit_vr1_rzn14 crit_vr1_IAE crit_vr1_am crit_vr1_chr]
disp(' ');
disp('Crit GP2 D');
[crit_vd2_drmo crit_vd2_rzn20 crit_vd2_rzn14 crit_vd2_IAE crit_vd2_am crit_vd2_chr]
disp(' ');
disp('Crit GP2 R');
[crit_vr2_drmo crit_vr2_rzn20 crit_vr2_rzn14 crit_vr2_IAE crit_vr2_am crit_vr2_chr]
disp(' ');
disp('Crit GP3 D');
[crit_vd3_drmo crit_vd3_rzn20 crit_vd3_rzn14 crit_vd3_IAE crit_vd3_am crit_vd3_chr]
disp(' ');
disp('Crit GP3 R');
[crit_vr3_drmo crit_vr3_rzn20 crit_vr3_rzn14 crit_vr3_IAE crit_vr3_am crit_vr3_chr]
disp(' ');
disp('Crit GP4 D');
[crit_vd4_drmo crit_vd4_rzn20 crit_vd4_rzn14 crit_vd4_IAE crit_vd4_am crit_vd4_chr]
disp(' ');
disp('Crit GP4 R');
[crit_vr4_drmo crit_vr4_rzn20 crit_vr4_rzn14 crit_vr4_IAE crit_vr4_am crit_vr4_chr]

