% function [Kp,Ki,Kd,b] = IAEPID_load (tr,tl,Kpr);
% Faster response

function [Kp,Ki,Kd,b] = IAEPID_load (tr,tl,Kpr);

tau=tl/tr;

Kpc=0.98089*tau^(-0.76167)/Kpr;
Tic=tr*tau^1.05211/0.91032;
Tdc=0.59974*tr*tau^0.89819;

Kp = Kpc*(Tic+Tdc)/Tic;
Ti = Tic+Tdc;
Td = Tic*Tdc/(Tic+Tdc);

b=0;
Ki = Kp/Ti;
Kd = Kp*Td;
