% function [Kp,Ki,Kd,b] = amigopid (tr,tl,Kpr);
% Faster response

function [Kp,Ki,Kd,b] = amigopid (tr,tl,Kpr);

tau=tl/(tl+tr);

Kp=(0.2+0.45*tr/tl)/Kpr;
Ti=(0.4*tl + 0.8*tr)*tl/(tl + 0.1*tr);
Td=0.5*tl*tr/(0.3*tl + tr);
if (tau <= 0.5)
   b=0;
else
   b=1;
end;
Ki = Kp/Ti;
Kd = Kp*Td;

