% function [crit_v] = calc_crit0 (y);

function [crit_v] = calc_crit0 (y);

err = y(:,2)-y(:,4);
u = y(:,3);
t = y(:,1);
yv = y(:,2);
size1 = max(size(t));
Ts = (t(size1)-t(1))/(size1-1);

IE = sum(err)*Ts;
IAE = sum(abs(err))*Ts;
ISE = sum(err.^2)*Ts;
ITSE = sum(err.^2.*t)*Ts;
ISU = sum(u.^2)*Ts;
IAUD = sum(abs(diff(u)));
ISUD = sum((diff(u)).^2);
errd = sum(abs(diff(yv)));
errdt = sum(abs(diff(yv)).*t(1:size1-1));
osc = sqrt(sum(abs(diff(diff(yv))))*IAE);		% Oscillation factor
IAEpath = IAE*errd^2;

crit_v = [IE;IAE;ISE;ISU;ISUD;IAUD;errd;errdt;IAE*errd;osc;IAEpath;IAE*osc;IAE*sqrt(IAUD)];