% function [Kp,Ki,Kd,b] = refzn_pid_14 (tr,tl,Kpr);
% Faster response

function [Kp,Ki,Kd,b] = refzn_pid_14 (tr,tl,Kpr);

tau=tl/(tl+tr);

Kp=3.8*tr/tl*exp(-8.4*tau+7.3*tau*tau)/Kpr;
Ti=0.46*tr*exp(2.8*tau-2.1*tau*tau);
Td=0.077*tr*exp(5.0*tau-4.8*tau*tau);
b=0.40*exp(0.18*tau+2.8*tau*tau);
Ki = Kp/Ti;
Kd = Kp*Td;

