% function [Kp,Ki,Kd,b] = refzn_pid_20 (tr,tl,Kpr);
% Faster response

function [Kp,Ki,Kd,b] = refzn_pid_20 (tr,tl,Kpr);

tau=tl/(tl+tr);

Kp=8.4*tr/tl*exp(-9.6*tau+9.8*tau*tau)/Kpr;
Ti=0.28*tr*exp(3.8*tau-1.6*tau*tau);
Td=0.076*tr*exp(3.4*tau-1.1*tau*tau);
b=0.22*exp(0.65*tau+0.051*tau*tau);
Ki = Kp/Ti;
Kd = Kp*Td;

